<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AffiliationInfo StructType
 * @subpackage Structs
 */
class AffiliationInfo extends AbstractStructBase
{
    /**
     * The SendAwards
     * @var bool
     */
    public $SendAwards;
    /**
     * Constructor method for AffiliationInfo
     * @uses AffiliationInfo::setSendAwards()
     * @param bool $sendAwards
     */
    public function __construct($sendAwards = null)
    {
        $this
            ->setSendAwards($sendAwards);
    }
    /**
     * Get SendAwards value
     * @return bool|null
     */
    public function getSendAwards()
    {
        return $this->SendAwards;
    }
    /**
     * Set SendAwards value
     * @param bool $sendAwards
     * @return \StructType\AffiliationInfo
     */
    public function setSendAwards($sendAwards = null)
    {
        // validation for constraint: boolean
        if (!is_null($sendAwards) && !is_bool($sendAwards)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($sendAwards, true), gettype($sendAwards)), __LINE__);
        }
        $this->SendAwards = $sendAwards;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AffiliationInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
