<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HotelInfoType StructType
 * @subpackage Structs
 */
class HotelInfoType extends AbstractStructBase
{
    /**
     * The Descriptions
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Descriptions
     */
    public $Descriptions;
    /**
     * The Position
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Position
     */
    public $Position;
    /**
     * The Services
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfHotelInfoTypeService
     */
    public $Services;
    /**
     * The Languages
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfHotelInfoTypeLanguage
     */
    public $Languages;
    /**
     * Constructor method for HotelInfoType
     * @uses HotelInfoType::setDescriptions()
     * @uses HotelInfoType::setPosition()
     * @uses HotelInfoType::setServices()
     * @uses HotelInfoType::setLanguages()
     * @param \StructType\Descriptions $descriptions
     * @param \StructType\Position $position
     * @param \ArrayType\ArrayOfHotelInfoTypeService $services
     * @param \ArrayType\ArrayOfHotelInfoTypeLanguage $languages
     */
    public function __construct(\StructType\Descriptions $descriptions = null, \StructType\Position $position = null, \ArrayType\ArrayOfHotelInfoTypeService $services = null, \ArrayType\ArrayOfHotelInfoTypeLanguage $languages = null)
    {
        $this
            ->setDescriptions($descriptions)
            ->setPosition($position)
            ->setServices($services)
            ->setLanguages($languages);
    }
    /**
     * Get Descriptions value
     * @return \StructType\Descriptions|null
     */
    public function getDescriptions()
    {
        return $this->Descriptions;
    }
    /**
     * Set Descriptions value
     * @param \StructType\Descriptions $descriptions
     * @return \StructType\HotelInfoType
     */
    public function setDescriptions(\StructType\Descriptions $descriptions = null)
    {
        $this->Descriptions = $descriptions;
        return $this;
    }
    /**
     * Get Position value
     * @return \StructType\Position|null
     */
    public function getPosition()
    {
        return $this->Position;
    }
    /**
     * Set Position value
     * @param \StructType\Position $position
     * @return \StructType\HotelInfoType
     */
    public function setPosition(\StructType\Position $position = null)
    {
        $this->Position = $position;
        return $this;
    }
    /**
     * Get Services value
     * @return \ArrayType\ArrayOfHotelInfoTypeService|null
     */
    public function getServices()
    {
        return $this->Services;
    }
    /**
     * Set Services value
     * @param \ArrayType\ArrayOfHotelInfoTypeService $services
     * @return \StructType\HotelInfoType
     */
    public function setServices(\ArrayType\ArrayOfHotelInfoTypeService $services = null)
    {
        $this->Services = $services;
        return $this;
    }
    /**
     * Get Languages value
     * @return \ArrayType\ArrayOfHotelInfoTypeLanguage|null
     */
    public function getLanguages()
    {
        return $this->Languages;
    }
    /**
     * Set Languages value
     * @param \ArrayType\ArrayOfHotelInfoTypeLanguage $languages
     * @return \StructType\HotelInfoType
     */
    public function setLanguages(\ArrayType\ArrayOfHotelInfoTypeLanguage $languages = null)
    {
        $this->Languages = $languages;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\HotelInfoType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
